=== debian/changelog ===
coq (8.3.pl4+dfsg-1) unstable; urgency=low

  * New upstream release
  * Replace proofgeneral-coq by proofgeneral in dependencies
  * Switch debian/copyright to format 1.0
  * Bump Standards-Version to 3.9.3

 -- Stéphane Glondu <glondu@debian.org>  Tue, 27 Mar 2012 07:59:07 +0200

coq (8.3.pl3+dfsg-2) unstable; urgency=low

  * Recompile with camlp5 6.04 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Mar 2012 18:59:12 +0100
