=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Ralf Treinen <treinen@debian.org>,
  Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.2
 Build-Depends:
  debhelper (>= 7.2.11~),
  dh-ocaml (>= 0.9.5~),
