=== debian/rules ===
--- 
+++ 
@@ -22,10 +22,11 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.3pl4
+COQ_VERSION := 8.4beta
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 CONFIGUREOPTS := --arch Linux --prefix /usr --mandir /usr/share/man \
+  --configdir /etc/xdg/coq \
   --emacslib /usr/share/emacs/site-lisp/coq \
   --browser "/usr/bin/x-www-browser %s &" \
   --with-doc no --coqrunbyteflags "-dllib -lcoqrun"
