## coq 8.4pl2dfsg

=== debian/changelog ===
coq (8.4pl2dfsg-4) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2013 19:54:49 +0100

coq (8.4pl2dfsg-3) experimental; urgency=low

  * Compile with OCaml 4.01.0
  * Disable micromega tests on Hurd (because of missing lockf)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Nov 2013 14:38:00 +0100

coq (8.4pl2dfsg-2) experimental; urgency=low

  * Compile with OCaml >= 4
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 26 Jul 2013 14:17:30 +0200

coq (8.4pl2dfsg-1) unstable; urgency=low

  * New upstream release
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Wed, 08 May 2013 18:10:14 +0200

coq (8.4pl1dfsg-1) experimental; urgency=low

  * New upstream release
    - 0002-Fix-use-of-HASNATDYNLINK-in-coq_makefile-output.patch
      has been merged upstream
    - add ocaml-findlib to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Sat, 29 Dec 2012 15:56:53 +0100

coq (8.4dfsg-2) experimental; urgency=low

  * Upstream bugfix: Fix use of $(HASNATDYNLINK) in coq_makefile output

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Sep 2012 12:43:13 +0200

coq (8.4dfsg-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 20 Aug 2012 18:33:45 +0200

coq (8.4~gamma0+really8.4beta2+dfsg-1) experimental; urgency=low

  * New upstream beta release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 05 Jun 2012 07:38:25 +0200

coq (8.4~beta+dfsg-4) experimental; urgency=low

  * Recompile with camlp5 6.05 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 06 Apr 2012 10:04:06 +0200

coq (8.3.pl4+dfsg-2) unstable; urgency=low

  * Recompile with camlp5 6.06 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 06 Jun 2012 07:35:26 +0200
