=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.4beta
+COQ_VERSION := 8.4pl2
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 CONFIGUREOPTS := --arch Linux --prefix /usr --mandir /usr/share/man \
